package de.intevation.flys.artifacts.model;

import java.util.List;

import de.intevation.flys.backend.SessionFactoryProvider;

import de.intevation.flys.model.Annotation;
import de.intevation.flys.model.Range;
import de.intevation.flys.model.River;

import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Query;


/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class AnnotationsFactory {

    public static List<Annotation> getAnnotations(River river) {
        return getAnnotations(river.getName());
    }


    public static List<Annotation> getAnnotations(String river) {
        SessionFactory sf = SessionFactoryProvider.getSessionFactory();
        Session session   = sf.openSession();

        try {
            Query rangesQuery = session.createQuery(
                "from Range where river.name=:name");
            rangesQuery.setParameter("name", river);
            List<Range> ranges = rangesQuery.list();

            Query query = session.createQuery(
                "from Annotation where range in (:ranges)");
            query.setParameterList("ranges", ranges);
            return query.list();
        }
        finally {
            session.close();
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
